%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                       %
%       Department of Electronics and Communication Engineering         %
%                        WANG WENBO - 238970                            %
%                                                                       %
%                        RMSE vs noise plot                             %
%                                                                       %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

close all;
clear all;
clc;

% loading... and initialization
load('RMSE.mat');
noise=10:10:100;

% mean rmse value for each starting point versus shadowing variance

% loading data
% hybrid model parameter set 1
temp1=mean(rmse(:,1:5),2);
temp2=mean(rmse(:,6:10),2);
temp3=mean(rmse(:,11:15),2);
temp4=mean(rmse(:,16:20),2);
% random direction model parameter set 1
temp5=mean(rmse(:,21:25),2);
temp6=mean(rmse(:,26:30),2);
temp7=mean(rmse(:,31:35),2);
temp8=mean(rmse(:,36:40),2);
% hybrid model parameter set 2
temp9=mean(rmse(:,41:45),2);
temp10=mean(rmse(:,46:50),2);
temp11=mean(rmse(:,51:55),2);
temp12=mean(rmse(:,56:60),2);
% random direction model parameter set 2
temp13=mean(rmse(:,61:65),2);
temp14=mean(rmse(:,66:70),2);
temp15=mean(rmse(:,71:75),2);
temp16=mean(rmse(:,76:80),2);

%%{
% plot

figure;
%hOut = inout.output();
%hOut.figure;

plot(noise,temp1,'b-s','linewidth',1.2,'markerface','b');grid on; hold on;
plot(noise,temp2,'m-s','linewidth',1.2,'markerface','m');
plot(noise,temp3,'g-s','linewidth',1.2,'markerface','g');
plot(noise,temp4,'r-s','linewidth',1.2,'markerface','r');

plot(noise,temp5,'b-d','linewidth',1.2,'markerface','b');
plot(noise,temp6,'m-d','linewidth',1.2,'markerface','m');
plot(noise,temp7,'g-d','linewidth',1.2,'markerface','g');
plot(noise,temp8,'r-d','linewidth',1.2,'markerface','r');

plot(noise,temp9,'b-^','linewidth',1.2,'markerface','b');
plot(noise,temp10,'m-^','linewidth',1.2,'markerface','m');
plot(noise,temp11,'g-^','linewidth',1.2,'markerface','g');
plot(noise,temp12,'r-^','linewidth',1.2,'markerface','r');

plot(noise,temp13,'b-v','linewidth',1.2,'markerface','b');
plot(noise,temp14,'m-v','linewidth',1.2,'markerface','m');
plot(noise,temp15,'g-v','linewidth',1.2,'markerface','g');
plot(noise,temp16,'r-v','linewidth',1.2,'markerface','r');

xlabel('Shadowing \sigma_{ap} [dB]');ylabel('RMSE [m]');
text(80,21.544792025452232,'\leftarrow Random Direction');
text(80,temp2(8),'\leftarrow Hybrid Model');
%title('');
%}

figure;

plot(noise,temp1,'-s',noise,temp2,'-^',noise,temp3,'-v',noise,temp4,'-o');
grid on;
xlabel('Shadowing Variance \sigma^2 [dB] - small range velocity');ylabel('RMSE [m]');
legend('starting point:(0,0,0)','starting point:(29.1,49.2,6.0)','starting point:(6.8,3.1,6.0)','starting point:(3.4,24.9,0.0)',...
    'location','southeast');

figure;

plot(noise,temp9,'-s',noise,temp10,'-^',noise,temp11,'-v',noise,temp12,'-o');
grid on;
xlabel('Shadowing \sigma_{ap} [dB] - large range velocity');ylabel('RMSE [m]');
legend('starting point:(0,0,0)','starting point:(29.1,49.2,6.0)','starting point:(6.8,3.1,6.0)','starting point:(3.4,24.9,0.0)',...
    'location','southeast');

figure;

plot(noise,temp5,'-s',noise,temp6,'-^',noise,temp7,'-v',noise,temp8,'-o');
grid on;
xlabel('Shadowing \sigma_{ap} [dB] - small range velocity');ylabel('RMSE [m]');
legend('starting point:(0,0,0)','starting point:(29.1,49.2,6.0)','starting point:(6.8,3.1,6.0)','starting point:(3.4,24.9,0.0)',...
    'location','southeast');

figure;

plot(noise,temp13,'-s',noise,temp14,'-^',noise,temp15,'-v',noise,temp16,'-o');
grid on;
xlabel('Shadowing \sigma_{ap} [dB] - large range velocity');ylabel('RMSE [m]');
legend('starting point:(0,0,0)','starting point:(29.1,49.2,6.0)','starting point:(6.8,3.1,6.0)','starting point:(3.4,24.9,0.0)',...
    'location','southeast');