%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                      %
% plot fp spatial structure                                            %
% Author: Wenbo Wang                                                   %
% Date: 1st Aug. 2015 -- the 1st version                               %
%                                                                      %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                      %                  
% note: 1.this script is highly dependent on the structure of loaded   %
%       data, therefore before you use it check if this script is fit  %
%       to your data structure or not.                                 %
%                                                                      %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% close all the figures, clear all the variables in the workspace and clear
% the screen
close all;
clear all;
clc;

load('fp_10_noise.mat');

len=length(fingerPrint);
temp=zeros(len,3);

for n=1:len
    
    temp(n,:)=fingerPrint{1,n};
    
end

figure;
plot3(temp(:,1),temp(:,2),temp(:,3),'k*');
grid on; axis([0 50 0 50 0 9]);
set(gca,'ztick',[3 6 9]);
text(0,25,11,'Fingerprints Grid');
xlabel('x [m]');
ylabel('y [m]');
zlabel('z [m]');