%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                      %
% plot fp statistical characterization                                 %
% Author: Wenbo Wang                                                   %
% Date: 1st Aug. 2015 -- the 1st version                               %
%                                                                      %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%                                                                      %                  
% note: 1.this script is highly dependent on the structure of loaded   %
%       data, therefore before you use it check if this script is fit  %
%       to your data structure or not.                                 %
%                                                                      %
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

% close all the figures, clear all the variables in the workspace and clear
% the screen
close all;
clear all;
clc;

%load('fp_2_noise.mat');
%load('fp_10_noise.mat');
%load('fp_40_noise.mat');
%load('fingerPrint_uni_bulid1_new.mat');
load('fingerPrint_uni_bulid2.mat');

len=length(fingerPrint);
len1=length(fingerPrint{2,1});

temp=zeros(len*2,len1);

for n=1:len
    
    temp(2*n-1:2*n,:)=fingerPrint{2,n};
    
end

temp1=temp(2:2:end,:);

temp2=~isnan(temp1);
temp3=sum(temp2,2);
temp4=sum(temp2);
mean1=mean(temp3)/len1
median1=median(temp3)/len1
std1=std(temp3,1)

figure;
[a1,b1]=hist(temp3);
h1=plot(b1/len1,cumsum(a1)/sum(a1),'r');hold on;
h2=bar(b1/len1,a1/sum(a1));hold off;
xlabel('heard AP/total AP');ylabel('Probability');
legend([h1,h2],'Cumulative Distribution Function (CDF)','Probality Distribution Function (PDF)','location','northwest');

mean2=nanmean(temp1,2);
std2=nanstd(temp1,1,2);
median2=nanmedian(temp1,2);

figure;
[a2,b2]=hist(mean2);
h3=plot(b2,cumsum(a2)/sum(a2),'r');hold on;
h4=bar(b2,a2/sum(a2));hold off;
xlabel('APs mean power level for each fingerprint point [dBm]');ylabel('Probability')
legend([h3,h4],'Cumulative Distribution Function (CDF)','Probality Distribution Function (PDF)','location','northwest');
figure;
[a3,b3]=hist(std2);
h5=plot(b3,cumsum(a3)/sum(a3),'r');hold on;
h6=bar(b3,a3/sum(a3));hold off;
xlabel('stadnard deviation of APs power level for each fingerprint point [dB]');ylabel('Probability')
legend([h5,h6],'Cumulative Distribution Function (CDF)','Probality Distribution Function (PDF)','location','northwest');
figure;
[a4,b4]=hist(median2);
h7=plot(b4,cumsum(a4)/sum(a4),'r');hold on;
h8=bar(b4,a4/sum(a4));hold off;
xlabel('APs median power level for each fingerprint point [dBm]');ylabel('Probability')
legend([h7,h8],'Cumulative Distribution Function (CDF)','Probality Distribution Function (PDF)','location','northwest');

