% reshape the real measurement fingerprint
clear all;
close all;
clc;

load('FingerprintingData_UniversityBuilding2.mat');
clear WLAN_grid_synthpoint N_floors mapped_meas_positions floor_heights;

% find the total number of APs
fp=WLAN_data_per_synthpoint;

clear WLAN_data_per_synthpoint;
[row,~]=size(fp);

max_each=zeros(row,1);
for p=1:row
    
    temp=fp{p,2}(1,:);
    max_each(p,:)=max(temp);
    
end

max_no=max(max_each);
clear p temp max_each;

% reshape the fingerprint database

% initial power and label matrix
fp_power=zeros(row*2,max_no);
fp_power(1:2:end,:)=repmat(1:max_no,row,1);

% form power matrix
temp2=1:max_no;
for p=1:row
    
    temp1=fp{p,2}(1,:);
    temp11=repmat(temp1.',1,max_no);
    temp22=repmat(temp2,length(temp1),1);
    dif=temp11-temp22;
    [row1,col,~]=find(~dif);
    [~,I]=sort(row1);
    col=col(I);
    fp_power(p*2,col)=fp{p,2}(2,:);
    
end
fp_power(fp_power==0)=nan;
clear p temp1 temp11 temp2 temp22 dif row1 col I;

% form new structure fingerprint database
fingerPrint=cell(2,row);
for p=1:row
    
    fingerPrint{1,p}=fp{p,1};
    fingerPrint{2,p}=fp_power(2*p-1:2*p,:);
    
end

save('fingerPrint_uni_bulid2.mat','fingerPrint','max_no');




