function [ecdf,acdf] = cdf(err,nan_val,step,max_val)
    if nargin == 3
        max_val=[];
    end
    %     assert(isvector(err),'Input must be a vector')
    
    %find the CDF of the distance error
    err = abs(err);
    len = size(err,1); % length of each vector
    nvc = size(err,2); % total number of err vectors
    
    err = sort(err);
    
    % replaces nan value if value provided
    if exist('nan_val','var') && ~isempty(nan_val);
        for n=1:nvc
            err(isnan(err(:,n)),n)=nan_val;
        end
    end
    
    % axis creation
    if exist('max_val','var')
        if isempty(max_val)
            M = max(err(:)); % max over all the err vectors
        else
            M = round(max_val+1);
        end
    else
        M = max(err(:)); % max over all the err vectors
    end
    m      = 0;
    if ~exist('step','var')
        step   = 1000;
    end
    acdf = m:(M-m)/step:M; % common axis creation
    
    % computes the cdf
    ecdf=zeros(length(acdf),nvc);
    for n=1:nvc
        for k=1:length(acdf),
            ecdf(k,n)=sum(err(:,n)<=acdf(k))./len;
        end;
    end
end