classdef (Abstract) fingerprint < handle
    
    
    
    
    
    
    
    methods(Static)
        
        function llh = likelihood(sigma,Pdiff)
            llh = 1/sqrt(2*pi*sigma^2)*exp(-(Pdiff).^2/2/(sigma.^2));
        end
        
        
       function estimate(hStorage,fingerprints,em_sel,nbFps,nbEm,db,db_pos,sigma,nbNeighbours)
            % now I want to get the likelihood for each grid point
            head  = 1;
            len   = nbEm;
            fplen = length(em_sel);
            hStorage.pest = NaN(nbFps,3);
            for k = 1:nbFps
                % For each FP chunk,
                fps  = fingerprints.meas(head:head+len-1,1); %contains fps for all
                
                % break this into smaller loops
                rxd  = bsxfun(@minus,db,repmat(fps(em_sel),size(db,1)/fplen,1));
                
                
                llh  = radio.fingerprint.likelihood(sigma,rxd); % likelihood vector for the n-th fingerprint
                
                % computes the cost and rerieves the index
                if ~all(isnan(llh))
                score = nansum(reshape(llh,fplen,length(llh)/fplen),1); % reshape into N_AP x board and sums rows
                [~,pos] = sort(score,'descend'); % kudos Simona, sort keeps the index information from the vector
                hStorage.pest(k,:) = mean(db_pos(pos(1:nbNeighbours),:),1);
                else
                    %does nothing, since it has been prealocated with NaN
                end
                % compute the likehood for each db entry.
                head  = head+len;
            end
       end     
    end
   
    methods
        
        function obj = fingerprint(varargin)
                %nothing is done
        end
        
        
    end
    
end